/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"

#define __KEYBIOS_H__
#include "fxlib.h"
#include "MonochromeLib.h"
#ifndef OS2Change
#define OS2Change
#ifndef OS2Change_GetOS2
#define OS2Change_GetOS2
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
#endif
#ifndef OS2Change_Keyboard
#define OS2Change_Keyboard
#define SCA 0xD201D002
#define SCB 0x422B0009
#define SCE 0x80010070
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
typedef int(*sc_i2cp2sip) (char*, char*, short int*, short int*);
const unsigned int sc0015[] = {SCA, SCB, SCE, 0x15};

int OSVersionAsInt(void)
{
	unsigned char mainversion;
	unsigned char minorversion;
	unsigned short release;
	unsigned short build;
	GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
	return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
void delay(void)
{
char i;
for (i=0; i<5; i++){};
}
unsigned char CheckKeyRow(unsigned char code)
{
	unsigned char result=0;
	short*PORTB_CTRL=(void*)0xA4000102;
	short*PORTM_CTRL=(void*)0xA4000118;
	char*PORTB=(void*)0xA4000122;
	char*PORTM=(void*)0xA4000138;
	char*PORTA=(void*)0xA4000120;
	short smask;
	char cmask;
	unsigned char column, row;

	column = code>>4;
	row = code &0x0F;

	smask = 0x0003 << (( row %8)*2);
	cmask = ~( 1 << ( row %8) );
	if(row <8)
	{
		*PORTB_CTRL = 0xAAAA ^ smask;
		*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
		delay();
		*PORTB = cmask;
		*PORTM = (*PORTM & 0xF0 ) | 0x0F;
	}
	else
	{
		*PORTB_CTRL = 0xAAAA;
		*PORTM_CTRL = ((*PORTM_CTRL & 0xFF00 ) | 0x00AA)  ^ smask;
		delay();
		*PORTB = 0xFF;
		*PORTM = (*PORTM & 0xF0 ) | cmask;
	}
	delay();
	result = (~(*PORTA))>>column & 1;
	delay();
	*PORTB_CTRL = 0xAAAA;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
	delay();
	*PORTB_CTRL = 0x5555;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x0055;
	delay();



	return result;
}



unsigned char key_down(unsigned char code)
{
	unsigned short key[8];
	const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
	unsigned char row;

	if(isOS2)
        {
		memcpy(&key, keyboardregister, sizeof(unsigned short) << 3);
		row= code%10;
		return (0 != (key[row >> 1] & 1 << code / 10 - 1 + ((row & 1) << 3)));
        }
	else
        {
        return CheckKeyRow((code % 10) + ((code / 10 - 1) << 4));
        }
}
unsigned char GetKeyMod(unsigned int *key)
{
unsigned char x, ret;

ret = GetKey(key);

for(x = 0; x < 80; x++)
{
  if(key_down(x))
  {
   *key = x;
   break;
  }
}
return ret;
}
#define IsKeyDown(x) key_down(x)
#define isKeyDown(x) key_down(x)
#define IsKeyUp(x) !key_down(x)
#define GetKey(x) GetKeyMod(x)
#endif
#endif

char* cells;
char* cells_;
char connectedSides=1;
char playing=0;

char isCell(char x, char y){
	int x_=x/8;
	int mask;
	if(x%8==0) mask=128;
	else if(x%8==1) mask=64;
	else if(x%8==2) mask=32;
	else if(x%8==3) mask=16;
	else if(x%8==4) mask=8;
	else if(x%8==5) mask=4;
	else if(x%8==6) mask=2;
	else if(x%8==7) mask=1;
	return cells[x_+8*y]&mask;
}

char getCellConnected(char x, char y){
	if(x==-1)x=63;
	else if(x==64)x=0;
	if(y==-1)y=31;
	else if(y==32)y=0;
	return isCell(x,y);
}
char getCellUnconnected(char x, char y){
	if(x!=-1&&x!=64&&y!=-1&&y!=32) return isCell(x,y);
	return 0;
}
char getCell(char x, char y){
	if(connectedSides) return getCellConnected(x,y);
	else return getCellUnconnected(x,y);
}

void reverseCell(char x, char y){
	int x_=x/8;
	int mask;
	if(x%8==0) mask=128;
	else if(x%8==1) mask=64;
	else if(x%8==2) mask=32;
	else if(x%8==3) mask=16;
	else if(x%8==4) mask=8;
	else if(x%8==5) mask=4;
	else if(x%8==6) mask=2;
	else if(x%8==7) mask=1;
	cells[x_+8*y]^=mask;
}
void reverseCell_(char x, char y){
	int x_=x/8;
	int mask;
	if(x%8==0) mask=128;
	else if(x%8==1) mask=64;
	else if(x%8==2) mask=32;
	else if(x%8==3) mask=16;
	else if(x%8==4) mask=8;
	else if(x%8==5) mask=4;
	else if(x%8==6) mask=2;
	else if(x%8==7) mask=1;
	cells_[x_+8*y]^=mask;
}

char boolToChar(char boolean){
	return boolean!=0;
}

char countNear(char x, char y){
	char tot=0;
	tot+=boolToChar(getCell(x-1,y-1));
	tot+=boolToChar(getCell(x-1,y+1));
	tot+=boolToChar(getCell(x-1,y));
	tot+=boolToChar(getCell(x,y-1));
	tot+=boolToChar(getCell(x,y+1));
	tot+=boolToChar(getCell(x+1,y-1));
	tot+=boolToChar(getCell(x+1,y+1));
	return tot+boolToChar(getCell(x+1,y));
}

void arrayCopy(char* from, char* to, int len){
	int i;
	for(i=0;i<len;i++) to[i]=from[i];
}
void arrayFill(char* arr, char value, int len){
	int i;
	for(i=0;i<len;i++) arr[i]=value;
}

void cycleCells(){
	char* tmp;
	char x,y,count,on;
	arrayCopy(cells,cells_,256);
	for(x=0;x<64;x++) for(y=0;y<32;y++){
		count=countNear(x,y);
		if(isCell(x,y)){
			if(count!=2&&count!=3)reverseCell_(x,y);
		}else{
			if(count==3) reverseCell_(x,y);
		}
	}
	tmp=cells_;
	cells_=cells;
	cells=tmp;
}

void drawAllCells(){
	char x,y;
	ML_clear_vram();
	for(x=0;x<64;x++){
		for(y=0;y<32;y++){
			if(isCell(x,y)){
				ML_pixel(2*x,2*y,ML_BLACK);
				ML_pixel(2*x+1,2*y,ML_BLACK);
				ML_pixel(2*x,2*y+1,ML_BLACK);
				ML_pixel(2*x+1,2*y+1,ML_BLACK);
			}
		}
	}
	ML_display_vram();
}

void glider(char x, char y){
	reverseCell(x+1,y);
	reverseCell(x+2,y+1);
	reverseCell(x,y+2);
	reverseCell(x+1,y+2);
	reverseCell(x+2,y+2);
}

void stopKey(int k){
	while(isKeyDown(k));
}
void waitForKey(int k){
	while(!isKeyDown(k));
}

void edit(){
	static char x=0,y=0;
	ML_pixel(x*2,y*2,ML_XOR);
	ML_display_vram();
	while(!isKeyDown(78)){
		if(isKeyDown(27)){
			ML_pixel(x*2,y*2,ML_XOR);
			x++;
			if(x==64) x=0;
			ML_pixel(x*2,y*2,ML_XOR);
			stopKey(27);
		}else if(isKeyDown(38)){
			ML_pixel(x*2,y*2,ML_XOR);
			x--;
			if(x==-1) x=63;
			ML_pixel(x*2,y*2,ML_XOR);
			stopKey(38);
		}else if(isKeyDown(28)){
			ML_pixel(x*2,y*2,ML_XOR);
			y--;
			if(y==-1) y=31;
			ML_pixel(x*2,y*2,ML_XOR);
			stopKey(28);
		}else if(isKeyDown(37)){
			ML_pixel(x*2,y*2,ML_XOR);
			y++;
			if(y==32) y=0;
			ML_pixel(x*2,y*2,ML_XOR);
			stopKey(37);
		}else if(isKeyDown(31)){
			reverseCell(x,y);
			ML_pixel(x*2,y*2,ML_XOR);
			ML_pixel(x*2+1,y*2,ML_XOR);
			ML_pixel(x*2,y*2+1,ML_XOR);
			ML_pixel(x*2+1,y*2+1,ML_XOR);
			stopKey(31);
		}else if(isKeyDown(77)){
			cycleCells();
			drawAllCells();
			ML_pixel(x*2,y*2,ML_XOR);
			stopKey(77);
		}else if(isKeyDown(44)){
			arrayFill(cells,0,256);
			ML_clear_vram();
			ML_pixel(x*2,y*2,ML_XOR);
			stopKey(77);
		}
		
		ML_display_vram();
	}
	stopKey(78);
	ML_pixel(x*2,y*2,ML_XOR);
	ML_display_vram();
}

void help(){
	ML_clear_vram();
	ML_display_vram();
	PopUpWin(6);
	locate(3,2);
	Print((unsigned char*)"Game go life help");
	locate(3,4);
	Print((unsigned char*)"[EXE] play/pause");
	locate(3,5);
	Print((unsigned char*)"[MENU] quit");
	locate(3,6);
	Print((unsigned char*)"[SHIFT] edit mode");
	locate(3,7);
	Print((unsigned char*)"[ALPHA] one frame");
	ML_display_vram();
}

int main(int isApp, unsigned short option){
	int key;
	ML_clear_screen();
	cells=(char*)malloc(256);
	cells_=(char*)malloc(256);
	
	arrayFill(cells,0,256);
	arrayFill(cells_,0,256);
	
	glider(2,2);
	drawAllCells();
	
	while(1){
		if(playing){
			cycleCells();
			drawAllCells();
			if(isKeyDown(31)){
				playing=0;
				stopKey(31);
			}
		}else{
			if(isKeyDown(31)){
				playing=1;
				stopKey(31);
			}else if(isKeyDown(48)){
				free(cells);
				free(cells_);
				GetKey(&key);
				return 1;
			}else if(isKeyDown(78)){
				stopKey(78);
				edit();
			}else if(isKeyDown(77)){
				cycleCells();
				drawAllCells();
				stopKey(77);
			}else if(isKeyDown(29)){
				stopKey(29);
				help();
				waitForKey(29);
				stopKey(29);
				drawAllCells();
			}
		}
	}
	return 1;
}
//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	while(main(isAppli, OptionNum));
}




//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

